#! /bin/sh

BROKER_ALLUP=${top_builddir}/allup/src/broker_allup
CBHEY=${top_builddir}/cbhey/src/cbhey

##

run_test $BROKER_ALLUP -V

check_output "Unable to get version?" <<EOF
${PACKAGE_VERSION}
EOF

##

$BROKER_ALLUP &
ALLUP_PID="$!"

trap 'kill $ALLUP_PID' EXIT

sleep 2

##

run_test $CBHEY -l

grep_output_for "IDL:edu/utah/pces/Allup:1.0" \
    "Unable to list supported interfaces?"

##

run_test $CBHEY -l

grep_output_for "IDL:edu/utah/pces/FactoryLibrary:1.0" \
    "Unable to list supported interfaces (2)?"

##

run_test $CBHEY file://allup.ior list

check_output "Unable to list properties?" <<EOF
library
libraries
EOF

##

run_test $CBHEY file://allup.ior list libraries

check_output "Unable to list libraries?" <<EOF
EOF

##

run_test $CBHEY file://allup.ior create library with name nonexistent

check_output "Able to create library with bogus name?" <<EOF
Error: No such library 'nonexistent': nonexistent.so: cannot open shared object file: No such file or directory
EOF

##
