
template behavior<method METH> RealTimeAdvocate_T ()
{
    qosket Qosket::Basic::BasicTaskQosket rta_Qosket;
    ivar Broker::RealTimeTask rta_Advocate;
    ivar unsigned long rta_Period;
    ivar unsigned long rta_Deadline;
    ivar unsigned long rta_UsageStart_Sec;
    ivar unsigned long rta_UsageStart_uSec;
    ivar unsigned long rta_TimeToGC;

    METH.signature {
	before PREMETHODCONTRACTEVAL {} // XXX

	before methodcall {
	    java_code #{
		long outer_start, start, end, diff;

		start = this.rta_Qosket.RUsage();
		if( (this.rta_UsageStart_Sec == 0) &&
		    (this.rta_UsageStart_uSec == 0) )
		{
		    this.rta_UsageStart_Sec = (int)(start / 1000000L);
		    this.rta_UsageStart_uSec = (int)(start % 1000000L);
		}
	    }#;
	}

	after methodcall {
	    java_code #{
		end = this.rta_Qosket.RUsage();
		outer_start = this.rta_UsageStart_Sec * 1000000;
		outer_start += this.rta_UsageStart_uSec;
		diff = end - start + (start - outer_start);
		this.rta_UsageStart_Sec = (int)(end / 1000000L);
		this.rta_UsageStart_uSec = (int)(end % 1000000L);
		try
		{
		    this.rta_Advocate.ReportCPU(this.rta_Advocate,
						(int)diff,
						(int)diff);
		}
		catch(Exception e)
		{
		    e.printStackTrace();
		}
		if( this.rta_TimeToGC == 0 )
		{
		    System.gc();
		    this.rta_TimeToGC = 2;
		}
		else
		{
		    this.rta_TimeToGC -= 1;
		}
	    }#;
	}
    }
};

/**
 * @sa Broker.idl
 * @sa RTServer.idl
 */
behavior ATRDelegate () {
    RealTimeAdvocate_T<FrameManip::Processor::process>;
};
