
// XXX #include "RealTimeAdvocate_T.asl"

template behavior<method METH> RealTimeAdvocate_T ()
{
    qosket Qosket::Basic::BasicTaskQosket rta_Qosket;
    ivar Broker::RealTimeTask rta_Advocate;
    ivar unsigned long rta_Period;
    ivar unsigned long rta_Deadline;
    ivar unsigned long rta_UsageStart_Sec;
    ivar unsigned long rta_UsageStart_uSec;

    METH.signature {
	before PREMETHODCONTRACTEVAL {} // XXX

	before methodcall {
	    cplusplus_code #{
		CORBA::ULongLong outer_start, start, end, diff;

		start = this->rta_Qosket->RUsage();
		if( (this->rta_UsageStart_Sec == 0) &&
		    (this->rta_UsageStart_uSec == 0) )
		{
		    this->rta_UsageStart_Sec = start / 1000000;
		    this->rta_UsageStart_uSec = start % 1000000;
		}
	    }#;
	}

	after methodcall {
	    cplusplus_code #{
		end = this->rta_Qosket->RUsage();
		outer_start = this->rta_UsageStart_Sec * 1000000;
		outer_start += this->rta_UsageStart_uSec;
		diff = end - start + (start - outer_start);
		this->rta_UsageStart_Sec = end / 1000000;
		this->rta_UsageStart_uSec = end % 1000000;
		if( !CORBA::is_nil(this->rta_Advocate) )
		{
		    try
		    {
			/* Send our report to the advocate. */
			this->rta_Advocate->ReportCPU(this->rta_Advocate,
						      (CORBA::ULong)diff,
						      (CORBA::ULong)diff);
		    }
		    catch(Broker::InvalidStatus &is)
		    {
			cout << "Exception: " << is << endl;
			exit(1);
		    }
		    catch(CORBA::SystemException &se)
		    {
			cout << "CORBA Exception: " << se << endl;
			exit(1);
		    }
		    catch(...)
		    {
			cout << "Unhandled exception" << endl;
		    }
		}
	    }#;
	}
    }
};

/**
 * @sa Broker.idl
 * @sa RTServer.idl
 */
behavior RTServerDelegate () {
    RealTimeAdvocate_T<RTServer::Periodic>;
};
