/*
 * GlacialTaskAdvocate.cc
 *
 * Copyright (c) 2003 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

/**
 * @file GlacialTaskAdvocate.cc
 *
 * Implementation of the GlacialTaskAdvocate class.
 */

#include "config.h"

#include "GlacialTaskAdvocate.hh"

GlacialTaskAdvocate::GlacialTaskAdvocate(void)
{
    this->gta_LastAdvice = 0;
}

GlacialTaskAdvocate::~GlacialTaskAdvocate(void)
{
}

void GlacialTaskAdvocate::ReportCPU(Broker::RealTimeTask_ptr rtt,
				    CORBA::ULong status,
				    CORBA::ULong advice)
    throw (CORBA::SystemException)
{
    CORBA::ULong change;

    if( CORBA::is_nil(this->dm_RemoteObject) )
    {
	throw CORBA::BAD_INV_ORDER();
    }
    
    if( advice > this->gta_LastAdvice )
    {
	change = advice - this->gta_LastAdvice;
	advice = this->gta_LastAdvice + (change / 4) + 10;
    }
    else
    {
	change = this->gta_LastAdvice - advice;
	advice = this->gta_LastAdvice - (change / 4);
    }
    this->gta_LastAdvice = advice;
    this->RealTimeTaskDelegateImpl::ReportCPU(rtt, status, advice);
}
