#! /bin/sh

BROKER_ALLUP=${top_builddir}/allup/src/broker_allup
CBHEY=${top_builddir}/cbhey/src/cbhey

$BROKER_ALLUP &
ALLUP_PID="$!"

trap 'kill $ALLUP_PID' EXIT

sleep 2

$CBHEY file://allup.ior create library with name ${top_builddir}/libbroker/src/.libs/libcpu-broker > cb.ior
$CBHEY file://allup.ior create library with name ${top_builddir}/task_factories/src/.libs/libtask_factories > task_factories.ior

$CBHEY file://cb.ior create manager with name dummy > manager.ior
$CBHEY file://cb.ior create stub-real-time-task with name srtt > srtt.ior

$CBHEY file://task_factories.ior create max-decay-task-advocate with name mdta > mdta.ior
$CBHEY -c IDL:BrokerDelegates/Delegate:1.0 file://mdta.ior set remote-object to file://srtt.ior > /dev/null

##

run_test $CBHEY -c IDL:Broker/RealTimeTask:1.0 file://mdta.ior execute begin-cpu-scheduling with manager file://manager.ior period 1s

check_output "Unable to begin-cpu-scheduling?" <<EOF
ok
EOF

##

run_test $CBHEY -c IDL:Broker/RealTimeTask:1.0 file://mdta.ior execute report-cpu with status 50000 advice 50000

check_output "Unable to report CPU usage?" <<EOF
ok
EOF

##

run_test $CBHEY -c IDL:Broker/RealTimeTask:1.0 file://mdta.ior get compute

check_output "Unable to get new compute time?" <<EOF
50500
EOF

##

run_test $CBHEY -c IDL:Broker/RealTimeTask:1.0 file://mdta.ior execute report-cpu with status 40000 advice 40000

check_output "Unable to report CPU usage (2)?" <<EOF
ok
EOF

##

run_test $CBHEY -c IDL:Broker/RealTimeTask:1.0 file://mdta.ior get compute

check_output "Unable to get new compute time (2)?" <<EOF
50500
EOF

##

run_test $CBHEY -c IDL:Broker/RealTimeTask:1.0 file://mdta.ior execute report-cpu with status 60000 advice 60000

check_output "Unable to report CPU usage (3)?" <<EOF
ok
EOF

##

run_test $CBHEY -c IDL:Broker/RealTimeTask:1.0 file://mdta.ior get compute

check_output "Unable to get new compute time (3)?" <<EOF
60600
EOF

##

run_test $CBHEY file://srtt.ior execute end-cpu-scheduling

check_output "Unable to end-cpu-scheduling?" <<EOF
ok
EOF

##
